﻿Public Class Form1
    ' Define possible contact methods.
    Private Enum ContactMethod
        None = 0
        Email
        Phone
        SnailMail
    End Enum

    ' Define a structure to hold addresses.
    Private Structure Address
        Public Name As String
        Public Street As String
        Public City As String
        Public State As String
        Public Zip As String
        Public Email As String
        Public Phone As String
        Public PreferredMethod As ContactMethod
    End Structure

    ' Make a Dictionary to hold addresses.
    Private Addresses As Dictionary(Of String, Address) =
        New Dictionary(Of String, Address)()

    ' Make sure the ComboBox starts with an item selected.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        cboMethod.SelectedIndex = 0
    End Sub

    ' Add a new address.
    Private Sub btnAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAdd.Click
        Dim newAddress As Address
        newAddress.Name = txtName.Text
        newAddress.Street = txtStreet.Text
        newAddress.City = txtCity.Text
        newAddress.State = txtState.Text
        newAddress.Zip = txtZip.Text
        newAddress.Email = txtEmail.Text
        newAddress.Phone = txtPhone.Text
        newAddress.PreferredMethod =
            CType(cboMethod.SelectedIndex, ContactMethod)

        ' Add the name and address to the dictionary.
        Addresses.Add(txtname.Text, newAddress)

        ' Get ready for the next one.
        txtName.Clear()
        txtStreet.Clear()
        txtCity.Clear()
        txtState.Clear()
        txtZip.Clear()
        txtEmail.Clear()
        txtPhone.Clear()
        cboMethod.SelectedIndex = 0

        txtname.Focus()
    End Sub

    ' Look up an address.
    Private Sub btnFind_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFind.Click
        ' Get the Address.
        Dim selectedAddress As Address = Addresses(txtName.Text)

        ' Display the Address's values.
        txtname.Text = selectedAddress.Name
        txtStreet.Text = selectedAddress.Street
        txtCity.Text = selectedAddress.City
        txtState.Text = selectedAddress.State
        txtZip.Text = selectedAddress.Zip
        txtEmail.Text = selectedAddress.Email
        txtPhone.Text = selectedAddress.Phone
        cboMethod.SelectedIndex =
            CInt(selectedAddress.PreferredMethod)
    End Sub

    ' Remove this entry.
    Private Sub btnRemove_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRemove.Click
        Addresses.Remove(txtName.Text)

        ' Get ready for the next one.
        txtName.Clear()
        txtStreet.Clear()
        txtCity.Clear()
        txtState.Clear()
        txtZip.Clear()
        txtEmail.Clear()
        txtPhone.Clear()
        cboMethod.SelectedIndex = 0

        txtName.Focus()
    End Sub
End Class
