﻿Public Class Student
    ' The FailureWarning event.
    Public Event FailureWarning(ByVal sender As Student, ByVal new_average As Double)

    ' The student's name.
    Public Property Name As String

    ' The student's test scores.
    Private TestScores As List(Of Integer) = New List(Of Integer)

    ' Return the student's test average.
    ' Note that this throws an exception if there are no test scores.
    Public ReadOnly Property Average As Double
        Get
            Dim total As Integer = 0
            For Each score As Integer In TestScores
                total += score
            Next score

            Return total / TestScores.Count
        End Get
    End Property

    ' Add a new test score to the list.
    Public Sub AddTestScore(ByVal score As Integer)
        TestScores.Add(score)

        ' If Average < 60, raise the FailureWarning event.
        If Average < 60 Then
            RaiseEvent FailureWarning(Me, Average)
        End If
    End Sub
End Class
