﻿Public Class OverdraftAccount
    Inherits BankAccount

    ' Constructors. There is no empty constructor
    ' so the program must use this one.
    Public Sub New(ByVal initialBalance As Decimal)
        MyBase.New(initialBalance)
    End Sub

    ' Remove money from the account.
    Public Overrides Sub Debit(ByVal amount As Decimal)
        ' See if there is enough money.
        If (Balance >= amount) Then
            ' There is enough money. Just do it.
            _Balance -= amount
        Else
            ' There's not enough money. Charge a $50 overdraft fee.
            _Balance -= (amount + 50D)
        End If
    End Sub
End Class
