﻿Public Class Shape
    Public Property Bounds As Rectangle

    Public Sub New(ByVal x As Integer, ByVal y As Integer, ByVal width As Integer, ByVal height As Integer)
        Bounds = New Rectangle(x, y, width, height)
    End Sub

    ' Draw a box with an X in it using a pen and brush.
    Public Overridable Sub Draw(ByVal gr As Graphics, ByVal thePen As Pen, ByVal theBrush As Brush)
        gr.FillRectangle(theBrush, Bounds)
        gr.DrawRectangle(thePen, Bounds)
        gr.DrawLine(thePen, Bounds.Left, Bounds.Top, Bounds.Right, Bounds.Bottom)
        gr.DrawLine(thePen, Bounds.Right, Bounds.Top, Bounds.Left, Bounds.Bottom)
    End Sub

    ' Draw a box with an X in it.
    Public Overridable Sub Draw(ByVal gr As Graphics)
        Draw(gr, Pens.Red, Brushes.Transparent)
    End Sub
End Class
