﻿Imports System.IO

Public Class Form1
    ' Start at the startup directory.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        txtDirectory.Text = Application.StartupPath
    End Sub

    ' Search for files matching the pattern
    ' and containing the target string.
    Private Sub btnSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSearch.Click
        lstFiles.Items.Clear()

        ' Get the file pattern and target string.
        Dim pattern As String = cboPattern.Text
        Dim target As String = txtTarget.Text.ToLower()

        ' Search for files.
        Dim dirinfo As New DirectoryInfo(txtDirectory.Text)
        For Each info As FileInfo In
            dirinfo.GetFiles(pattern, SearchOption.AllDirectories)

            ' See if we need to look for target text.
            If (target.Length > 0) Then
                ' If this file contains the target string,
                ' add it to the list.
                Dim content As String = File.ReadAllText(info.FullName).ToLower()
                If (content.Contains(target)) Then lstFiles.Items.Add(info)
            Else
                ' Just add this file to the list.
                lstFiles.Items.Add(info)
            End If
        Next info
    End Sub
End Class
