﻿Public Class Form1
    ' Display a print preview.
    Private Sub btnPreview_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPreview.Click
        ppdShapes.ShowDialog()
    End Sub

    ' Print to the default printer.
    Private Sub btnPrint_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrint.Click
        pdocShapes.Print()
    End Sub

    ' The number of the next page.
    Private NextPageNum As Integer = 0

    ' Print a page.
    Private Sub pdocShapes_PrintPage(ByVal sender As System.Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles pdocShapes.PrintPage
        ' These are used to draw the triangle and diamond.
        Dim xmid As Single = CSng((e.MarginBounds.Left + e.MarginBounds.Right) / 2)
        Dim ymid As Single = CSng((e.MarginBounds.Top + e.MarginBounds.Bottom) / 2)

        ' See which page this is.
        Select NextPageNum
            Case 0 ' Draw a triangle.
                Dim trianglePoints() As PointF =
                {
                    New PointF(xmid, e.MarginBounds.Top),
                    New PointF(e.MarginBounds.Left, e.MarginBounds.Bottom),
                    New PointF(e.MarginBounds.Right, e.MarginBounds.Bottom)
                }
                Using the_pen As New Pen(Color.Red, 10)
                    e.Graphics.DrawPolygon(the_pen, trianglePoints)
                End Using

            Case 1 ' Draw a rectangle.
                Using the_pen As New Pen(Color.Blue, 10)
                    e.Graphics.DrawRectangle(the_pen, e.MarginBounds)
                End Using

            Case 2 ' Draw an ellipse.
                Using the_pen As New Pen(Color.Green, 10)
                    e.Graphics.DrawEllipse(the_pen, e.MarginBounds)
                End Using

            Case 3 ' Draw a diamond.
                Dim diamondPoints() As PointF =
                {
                    New PointF(xmid, e.MarginBounds.Top),
                    New PointF(e.MarginBounds.Right, ymid),
                    New PointF(xmid, e.MarginBounds.Bottom),
                    New PointF(e.MarginBounds.Left, ymid)
                }
                Using the_pen As New Pen(Color.Black, 10)
                    e.Graphics.DrawPolygon(the_pen, diamondPoints)
                End Using
        End Select

        NextPageNum += 1
        If (NextPageNum > 3) Then
            ' This is the last page. Start over if we print again.
            e.HasMorePages = False
            NextPageNum = 0
        Else
            ' We have more pages.
            e.HasMorePages = True
        End If
    End Sub
End Class
