﻿Imports System.IO

Public Class Form1
    ' Back up any files listed on the clipboard's file drop list.
    Private Sub btnBackup_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBackup.Click
        If Clipboard.ContainsFileDropList() Then
            BackupFiles(Clipboard.GetFileDropList())
        End If
    End Sub

    ' Backup the files.
    Private Sub BackupFiles(ByVal filenames As IList)
        ' Get the backup directory.
        Dim dirInfo As New DirectoryInfo(txtDirectory.Text)

        ' Create the directory if necessary.
        dirInfo.Create()

        ' Process the files.
        For Each filename As String In filenames
            Dim info As New FileInfo(filename)

            ' Add a version number to the end.
            ' Keep trying until we find one that isn't
            ' already there.
            Dim i As Integer = 1
            Do
                ' Compose a file name in the backup directory
                ' with the file's name and the version number.
                Dim newFileName As String =
                        Path.Combine(dirInfo.FullName, info.Name) &
                        "." & i.ToString("000")

                ' See if this file exists.
                If (Not File.Exists(newFileName)) Then
                    ' Copy the file here.
                    info.CopyTo(newFileName)

                    ' Exit the Do loop.
                    Exit Do
                End If
                i += 1
            Loop
        Next filename

        MessageBox.Show("Backed up " & filenames.Count & " files")
    End Sub

    ' Allow Copy of FileDrop.
    Private Sub Form1_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles Me.DragEnter
        If e.Data.GetDataPresent(DataFormats.FileDrop) Then
            e.Effect = DragDropEffects.Copy
        End If
    End Sub

    ' Accept a FileDrop.
    Private Sub Form1_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles Me.DragDrop
        If e.Data.GetDataPresent(DataFormats.FileDrop) Then
            ' Get the data.
            Dim filenames() As String = DirectCast(e.Data.GetData(DataFormats.FileDrop), String())
            BackupFiles(filenames)

            ' We copied.
            e.Effect = DragDropEffects.Copy
        End If
    End Sub
End Class
