﻿Public Class Form1
    ' Install an event handler to catch
    ' My.Computer.Network.NetworkAvailabilityChanged.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Check the network status now.
        CheckNetworkStatus()

        ' Register an event handler so we can detect changes
        ' in network availability.
        AddHandler _
            My.Computer.Network.NetworkAvailabilityChanged,
            AddressOf NetworkChanged
    End Sub

    ' Handle the My.Computer.Network.NetworkAvailabilityChanged event.
    Private Sub NetworkChanged(ByVal sender As System.Object, ByVal e As Microsoft.VisualBasic.Devices.NetworkAvailableEventArgs)
        CheckNetworkStatus()
    End Sub

    ' Indicate whether the network is available.
    Private Sub CheckNetworkStatus()
        ' See if the network is available.
        If My.Computer.Network.IsAvailable Then
            ' The network is available.
            lblStatus.Text = "Up!"
            lblStatus.ForeColor = Color.Green
            picStatus.Image = My.Resources.Happy
        Else
            ' The network is not available.
            lblStatus.Text = "Down"
            lblStatus.ForeColor = Color.Red
            picStatus.Image = My.Resources.Sad
        End If
    End Sub
End Class
