﻿Imports System.IO
Imports System.Globalization
Imports System.Threading

Public Class Form1
    ' Start the dialog in the code directory.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim dirInfo As New DirectoryInfo(Path.Combine(Application.StartupPath, "..\.."))
        ofdValue.InitialDirectory = dirInfo.FullName
    End Sub

    ' Load a file and read its values.
    Private Sub readFileButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReadFile.Click
        If ofdValue.ShowDialog() = Windows.Forms.DialogResult.OK Then
            ' Select the correct locale.
            Dim fileInfo As New FileInfo(ofdValue.FileName)
            Select Case fileInfo.Name
                Case "English.txt"
                    Thread.CurrentThread.CurrentCulture = New CultureInfo("en-US", False)
                Case "German.txt"
                    Thread.CurrentThread.CurrentCulture = New CultureInfo("de-DE", False)
                Case "Dutch.txt"
                    Thread.CurrentThread.CurrentCulture = New CultureInfo("nl-NL", False)
            End Select

            ' Read the file's lines.
            dgvValues.Rows.Clear()
            Dim lines() As String = File.ReadAllLines(ofdValue.FileName, System.Text.Encoding.UTF8)
            For Each line As String In lines
                ' Split the line into fields.
                Dim fields() As String = line.Split(New String() {vbTab}, StringSplitOptions.None)

                ' Parse the values.
                Dim item As String = fields(0)
                Dim unitPrice As Decimal = Decimal.Parse(fields(1), NumberStyles.Any)
                Dim quantity As Integer = Integer.Parse(fields(2), NumberStyles.Any)
                Dim totalPrice As Decimal = Decimal.Parse(fields(3), NumberStyles.Any)

                ' Display the values in the DataGridView.
                Dim values() As Object =
                {
                    item,
                    unitPrice.ToString("C"),
                    quantity.ToString(),
                    totalPrice.ToString("C")
                }
                dgvValues.Rows.Add(values)
            Next line
        End If
    End Sub
End Class
