﻿Public Class Form1
    ' Display customers selected in various ways.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim billDate As Date = #4/1/2011#
        'Dim billDate As Date = DateTime.Today

        Me.Text = "FindCustomers (" & billDate.ToString("d") & ")"

        ' Make the customers.
        Dim customers() As Customer =
        {
            New Customer() With {.FirstName = "Ann", .LastName = "Ashler", .Balance = 100, .DueDate = #3/10/2011#},
            New Customer() With {.FirstName = "Bob", .LastName = "Boggart", .Balance = 150, .DueDate = #2/5/2011#},
            New Customer() With {.FirstName = "Cindy", .LastName = "Carruthers", .Balance = -50, .DueDate = #3/17/2011#},
            New Customer() With {.FirstName = "Dan", .LastName = "Dent", .Balance = -75, .DueDate = #2/10/2011#},
            New Customer() With {.FirstName = "Eve", .LastName = "Edwards", .Balance = 0, .DueDate = #2/10/2011#},
            New Customer() With {.FirstName = "Frank", .LastName = "Finkle", .Balance = -95, .DueDate = #3/9/2011#},
            New Customer() With {.FirstName = "Gina", .LastName = "Garra", .Balance = -10, .DueDate = #3/30/2011#}
        }

        ' Display all customers.
        lstAll.DataSource = customers

        ' Display customers with negative balances.
        Dim negativeQuery =
            From cust As Customer In customers
            Where (cust.Balance < 0)
            Select cust
            ' Place before the Select clause:
            '   Order By cust.Balance Ascending, cust.FirstName
        lstNegativeBalance.DataSource = negativeQuery.ToArray()

            ' Display customers who owe at least $50.
        Dim owes50Query =
            From cust As Customer In customers
            Where (cust.Balance <= -50)
            Select cust
        lstOwes50.DataSource = owes50Query.ToArray()

            ' Display customers who owe at least $50
            ' and are overdue at least 30 days.
        Dim overdueQuery =
            From cust As Customer In customers
            Where (cust.Balance <= -50) AndAlso
                  (billDate.Subtract(cust.DueDate).TotalDays > 30)
            Select cust
        lstOverdue.DataSource = overdueQuery.ToArray()
    End Sub
End Class
