﻿Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Make some Students.
        Dim students() As Student =
        {
            New Student() With {.FirstName = "Dan", .LastName = "Dent", .TestScores = New List(Of Integer) From {65, 65, 65}},
            New Student() With {.FirstName = "Gina", .LastName = "Garra", .TestScores = New List(Of Integer) From {100, 92, 100}},
            New Student() With {.FirstName = "Frank", .LastName = "Finkle", .TestScores = New List(Of Integer) From {50, 30, 70}},
            New Student() With {.FirstName = "Eve", .LastName = "Edwards", .TestScores = New List(Of Integer) From {97, 96, 99}},
            New Student() With {.FirstName = "Cindy", .LastName = "Carruthers", .TestScores = New List(Of Integer) From {51, 63, 55}},
            New Student() With {.FirstName = "Bob", .LastName = "Boggart", .TestScores = New List(Of Integer) From {95, 100, 92}},
            New Student() With {.FirstName = "Ann", .LastName = "Ashler", .TestScores = New List(Of Integer) From {90, 80, 71}}
        }

        ' Select all students and their test averages ordered by name.
        Dim allStudents =
            From stu As Student In students
            Order By stu.LastName, stu.FirstName
            Select stu.FirstName & " " & stu.LastName & vbTab &
                stu.TestScores.Average().ToString("0.00")
        allListBox.DataSource = allStudents.ToArray()

        ' Select passing students ordered by name.
        Dim passingStudents =
            From stu As Student In students
            Order By stu.LastName, stu.FirstName
            Where (stu.TestScores.Average() >= 60)
            Select stu.FirstName & " " & stu.LastName
        passingListBox.DataSource = passingStudents.ToArray()

        ' Select failing students ordered by name.
        Dim failingStudents =
            From stu As Student In students
            Order By stu.LastName, stu.FirstName
            Where stu.TestScores.Average() < 60
            Select stu.FirstName & " " & stu.LastName
        failingListBox.DataSource = failingStudents.ToArray()

        ' Select all scores and compute a class average.
        Dim allAverages =
            From stu As Student In students
            Order By stu.LastName, stu.FirstName
            Select stu.TestScores.Average()
        Dim classAverage As Double = allAverages.Average()

        ' Display the average.
        Me.Text = "FindStudents: Class Average = " & classAverage.ToString("0.00")

        ' Select students with average below the class average ordered by average.
        Dim belowAverageStudents =
            From stu As Student In students
            Order By stu.TestScores.Average()
            Where stu.TestScores.Average() < classAverage
            Select New With
            {
                .Name = stu.FirstName & " " & stu.LastName,
                .Average = stu.TestScores.Average()
            }
        For Each info In belowAverageStudents
            Debug.WriteLine(TypeName(info))
            belowAverageListBox.Items.Add(info.Name & vbTab & info.Average.ToString("0.00"))
        Next info
    End Sub
End Class
