-- Select the master database.
USE [master];

-- Delete the TestScoresDatabase.
-- IF EXISTS (SELECT * FROM sys.databases WHERE name = 'TestScoresDatabase')
-- 	DROP DATABASE TestScoresDatabase;

-- Create and use the TestScoresDatabase.
CREATE DATABASE TestScoresDatabase;
GO
USE TestScoresDatabase;

-- Create the Student table.
CREATE TABLE Student
(
	StudentId	int				PRIMARY KEY,
	FirstName	nvarchar(50)	NOT NULL,
	LastName	nvarchar(50)	NOT NULL,
)

-- Create the TestScore table.
CREATE TABLE TestScore
(
    StudentId	int				NOT NULL
		FOREIGN KEY REFERENCES Student (StudentId),
    TestNumber	int				NOT NULL,
	Score		int				NOT NULL,
	CONSTRAINT PK_OrderItem PRIMARY KEY (StudentId, TestNumber)
)

-- Insert data into the Student table.
INSERT INTO Student (StudentId, FirstName, LastName) VALUES (1, 'Art', 'Angler')
INSERT INTO Student (StudentId, FirstName, LastName) VALUES (2, 'Betty', 'Blunt')
INSERT INTO Student (StudentId, FirstName, LastName) VALUES (3, 'Carter', 'Casey')
INSERT INTO Student (StudentId, FirstName, LastName) VALUES (4, 'Dena', 'Dervish')
INSERT INTO Student (StudentId, FirstName, LastName) VALUES (5, 'Ed', 'Eager')
INSERT INTO Student (StudentId, FirstName, LastName) VALUES (6, 'Frieda', 'Finkle')

-- Insert data into the TestScore table.
INSERT INTO TestScore (StudentId, TestNumber, Score) VALUES (1, 1, 90);
INSERT INTO TestScore (StudentId, TestNumber, Score) VALUES (1, 2, 100);
INSERT INTO TestScore (StudentId, TestNumber, Score) VALUES (1, 3, 92);
INSERT INTO TestScore (StudentId, TestNumber, Score) VALUES (2, 1, 82);
INSERT INTO TestScore (StudentId, TestNumber, Score) VALUES (2, 2, 87);
INSERT INTO TestScore (StudentId, TestNumber, Score) VALUES (2, 3, 79);
INSERT INTO TestScore (StudentId, TestNumber, Score) VALUES (3, 1, 46);
INSERT INTO TestScore (StudentId, TestNumber, Score) VALUES (3, 2, 59);
INSERT INTO TestScore (StudentId, TestNumber, Score) VALUES (3, 3, 61);
INSERT INTO TestScore (StudentId, TestNumber, Score) VALUES (4, 1, 74);
INSERT INTO TestScore (StudentId, TestNumber, Score) VALUES (4, 2, 92);
INSERT INTO TestScore (StudentId, TestNumber, Score) VALUES (4, 3, 83);
INSERT INTO TestScore (StudentId, TestNumber, Score) VALUES (5, 1, 97);
INSERT INTO TestScore (StudentId, TestNumber, Score) VALUES (5, 2, 99);
INSERT INTO TestScore (StudentId, TestNumber, Score) VALUES (5, 3, 98);
INSERT INTO TestScore (StudentId, TestNumber, Score) VALUES (6, 1, 50);
INSERT INTO TestScore (StudentId, TestNumber, Score) VALUES (6, 2, 58);
INSERT INTO TestScore (StudentId, TestNumber, Score) VALUES (6, 3, 64);
